unit
  UZ80Var;

interface

uses
  ULoadROM, UGraph, UZ80;

type
  AByteArray = array[0..1023] of Byte;
  PByteArray = ^AByteArray;
  AByte = array[0..65531] of Byte;
  PByte = ^AByte;

const
  lStopEmulation: Boolean = false;
  lDumpReg: Boolean = false;
  lSlow: Boolean = false;
  GetMaxX: Integer = 320;
  GetMaxY: Integer = 240;
  nXPos: Integer = 0;
  nYPos: Integer = 0;
  lShowMouse: Boolean = false;
  nMoving: Integer= 0;
  lShowCPU: boolean = true;
  lScreenChanged: Boolean = true;
  nWatchDog: Integer = 0;
  lSound: Boolean = true;



var
  aZ80Mem: PByte;
  oROMSInfo: TROMSInfo;
  aZ80Regs: ^TZ80ASMRegs;

implementation

end.