procedure OpCodeDD; assembler;
asm
    xor  ax, ax
    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]

    { Update tick counter }
    mov  bx, ax
    xor  cx, cx
    mov  cl, byte ptr oCyclesXX[bx]
    add  word ptr si[TICKCOUNT], cx

    shl  ax, 2
    mov  bx, offset @IX_NOP
    add  ax, bx
    jmp  ax
  @IX_NOP:
    jmp  @IX_NOP_Func
    nop

  @IX_LD_BC_WORD:
    jmp  @IX_LD_BC_WORD_Func
    nop

  @IX_LD_xBC_A:
    jmp  @IX_LD_xBC_A_Func
    nop

  @IX_INC_BC:
    jmp  @IX_INC_BC_Func
    nop

  @IX_INC_B:
    jmp  @IX_INC_B_Func
    nop

  @IX_DEC_B:
    jmp  @IX_DEC_B_Func
    nop

  @IX_LD_B_BYTE:
    jmp  @IX_LD_B_BYTE_Func
    nop

  @IX_RLCA:
    jmp  @IX_RLCA_Func
    nop

  @IX_EX_AF_AF:
    jmp  @IX_EX_AF_AF_Func
    nop

  @IX_ADD_HL_BC:
    jmp  @IX_ADD_HL_BC_Func
    nop

  @IX_LD_A_xBC:
    jmp  @IX_LD_A_xBC_Func
    nop

  @IX_DEC_BC:
    jmp  @IX_DEC_BC_Func
    nop

  @IX_INC_C:
    jmp  @IX_INC_C_Func
    nop

  @IX_DEC_C:
    jmp  @IX_DEC_C_Func
    nop

  @IX_LD_C_BYTE:
    jmp  @IX_LD_C_BYTE_Func
    nop

  @IX_RRCA:
    jmp  @IX_RRCA_Func
    nop

  @IX_DJNZ:
    jmp  @IX_DJNZ_Func
    nop

  @IX_LD_DE_WORD:
    jmp  @IX_LD_DE_WORD_Func
    nop

  @IX_LD_xDE_A:
    jmp  @IX_LD_xDE_A_Func
    nop

  @IX_INC_DE:
    jmp  @IX_INC_DE_Func
    nop

  @IX_INC_D:
    jmp  @IX_INC_D_Func
    nop

  @IX_DEC_D:
    jmp  @IX_DEC_D_Func
    nop

  @IX_LD_D_BYTE:
    jmp  @IX_LD_D_BYTE_Func
    nop

  @IX_RLA:
    jmp  @IX_RLA_Func
    nop

  @IX_JR:
    jmp  @IX_JR_Func
    nop

  @IX_ADD_HL_DE:
    jmp  @IX_ADD_HL_DE_Func
    nop

  @IX_LD_A_xDE:
    jmp  @IX_LD_A_xDE_Func
    nop

  @IX_DEC_DE:
    jmp  @IX_DEC_DE_Func
    nop

  @IX_INC_E:
    jmp  @IX_INC_E_Func
    nop

  @IX_DEC_E:
    jmp  @IX_DEC_E_Func
    nop

  @IX_LD_E_BYTE:
    jmp  @IX_LD_E_BYTE_Func
    nop

  @IX_RRA:
    jmp  @IX_RRA_Func
    nop

  @IX_JR_NZ:
    jmp  @IX_JR_NZ_Func
    nop

  @IX_LD_HL_WORD:
    jmp  @IX_LD_HL_WORD_Func
    nop

  @IX_LD_xWORD_HL:
    jmp  @IX_LD_xWORD_HL_Func
    nop

  @IX_INC_HL:
    jmp  @IX_INC_HL_Func
    nop

  @IX_INC_H:
    jmp  @IX_INC_H_Func
    nop

  @IX_DEC_H:
    jmp  @IX_DEC_H_Func
    nop

  @IX_LD_H_BYTE:
    jmp  @IX_LD_H_BYTE_Func
    nop

  @IX_DAA:
    jmp  @IX_DAA_Func
    nop

  @IX_JR_Z:
    jmp  @IX_JR_Z_Func
    nop

  @IX_ADD_HL_HL:
    jmp  @IX_ADD_HL_HL_Func
    nop

  @IX_LD_HL_xWORD:
    jmp  @IX_LD_HL_xWORD_Func
    nop

  @IX_DEC_HL:
    jmp  @IX_DEC_HL_Func
    nop

  @IX_INC_L:
    jmp  @IX_INC_L_Func
    nop

  @IX_DEC_L:
    jmp  @IX_DEC_L_Func
    nop

  @IX_LD_L_BYTE:
    jmp  @IX_LD_L_BYTE_Func
    nop

  @IX_CPL:
    jmp  @IX_CPL_Func
    nop

  @IX_JR_NC:
    jmp  @IX_JR_NC_Func
    nop

  @IX_LD_SP_WORD:
    jmp  @IX_LD_SP_WORD_Func
    nop

  @IX_LD_xWORD_A:
    jmp  @IX_LD_xWORD_A_Func
    nop

  @IX_INC_SP:
    jmp  @IX_INC_SP_Func
    nop

  @IX_INC_xHL:
    jmp  @IX_INC_xHL_Func
    nop

  @IX_DEC_xHL:
    jmp  @IX_DEC_xHL_Func
    nop

  @IX_LD_xHL_BYTE:
    jmp  @IX_LD_xHL_BYTE_Func
    nop

  @IX_SCF:
    jmp  @IX_SCF_Func
    nop

  @IX_JR_C:
    jmp  @IX_JR_C_Func
    nop

  @IX_ADD_HL_SP:
    jmp  @IX_ADD_HL_SP_Func
    nop

  @IX_LD_A_xWORD:
    jmp  @IX_LD_A_xWORD_Func
    nop

  @IX_DEC_SP:
    jmp  @IX_DEC_SP_Func
    nop

  @IX_INC_A:
    jmp  @IX_INC_A_Func
    nop

  @IX_DEC_A:
    jmp  @IX_DEC_A_Func
    nop

  @IX_LD_A_BYTE:
    jmp  @IX_LD_A_BYTE_Func
    nop

  @IX_CCF:
    jmp  @IX_CCF_Func
    nop

  @IX_LD_B_B:
    jmp  @IX_LD_B_B_Func
    nop

  @IX_LD_B_C:
    jmp  @IX_LD_B_C_Func
    nop

  @IX_LD_B_D:
    jmp  @IX_LD_B_D_Func
    nop

  @IX_LD_B_E:
    jmp  @IX_LD_B_E_Func
    nop

  @IX_LD_B_H:
    jmp  @IX_LD_B_H_Func
    nop

  @IX_LD_B_L:
    jmp  @IX_LD_B_L_Func
    nop

  @IX_LD_B_xHL:
    jmp  @IX_LD_B_xHL_Func
    nop

  @IX_LD_B_A:
    jmp  @IX_LD_B_A_Func
    nop

  @IX_LD_C_B:
    jmp  @IX_LD_C_B_Func
    nop

  @IX_LD_C_C:
    jmp  @IX_LD_C_C_Func
    nop

  @IX_LD_C_D:
    jmp  @IX_LD_C_D_Func
    nop

  @IX_LD_C_E:
    jmp  @IX_LD_C_E_Func
    nop

  @IX_LD_C_H:
    jmp  @IX_LD_C_H_Func
    nop

  @IX_LD_C_L:
    jmp  @IX_LD_C_L_Func
    nop

  @IX_LD_C_xHL:
    jmp  @IX_LD_C_xHL_Func
    nop

  @IX_LD_C_A:
    jmp  @IX_LD_C_A_Func
    nop

  @IX_LD_D_B:
    jmp  @IX_LD_D_B_Func
    nop

  @IX_LD_D_C:
    jmp  @IX_LD_D_C_Func
    nop

  @IX_LD_D_D:
    jmp  @IX_LD_D_D_Func
    nop

  @IX_LD_D_E:
    jmp  @IX_LD_D_E_Func
    nop

  @IX_LD_D_H:
    jmp  @IX_LD_D_H_Func
    nop

  @IX_LD_D_L:
    jmp  @IX_LD_D_L_Func
    nop

  @IX_LD_D_xHL:
    jmp  @IX_LD_D_xHL_Func
    nop

  @IX_LD_D_A:
    jmp  @IX_LD_D_A_Func
    nop

  @IX_LD_E_B:
    jmp  @IX_LD_E_B_Func
    nop

  @IX_LD_E_C:
    jmp  @IX_LD_E_C_Func
    nop

  @IX_LD_E_D:
    jmp  @IX_LD_E_D_Func
    nop

  @IX_LD_E_E:
    jmp  @IX_LD_E_E_Func
    nop

  @IX_LD_E_H:
    jmp  @IX_LD_E_H_Func
    nop

  @IX_LD_E_L:
    jmp  @IX_LD_E_L_Func
    nop

  @IX_LD_E_xHL:
    jmp  @IX_LD_E_xHL_Func
    nop

  @IX_LD_E_A:
    jmp  @IX_LD_E_A_Func
    nop

  @IX_LD_H_B:
    jmp  @IX_LD_H_B_Func
    nop

  @IX_LD_H_C:
    jmp  @IX_LD_H_C_Func
    nop

  @IX_LD_H_D:
    jmp  @IX_LD_H_D_Func
    nop

  @IX_LD_H_E:
    jmp  @IX_LD_H_E_Func
    nop

  @IX_LD_H_H:
    jmp  @IX_LD_H_H_Func
    nop

  @IX_LD_H_L:
    jmp  @IX_LD_H_L_Func
    nop

  @IX_LD_H_xHL:
    jmp  @IX_LD_H_xHL_Func
    nop

  @IX_LD_H_A:
    jmp  @IX_LD_H_A_Func
    nop

  @IX_LD_L_B:
    jmp  @IX_LD_L_B_Func
    nop

  @IX_LD_L_C:
    jmp  @IX_LD_L_C_Func
    nop

  @IX_LD_L_D:
    jmp  @IX_LD_L_D_Func
    nop

  @IX_LD_L_E:
    jmp  @IX_LD_L_E_Func
    nop

  @IX_LD_L_H:
    jmp  @IX_LD_L_H_Func
    nop

  @IX_LD_L_L:
    jmp  @IX_LD_L_L_Func
    nop

  @IX_LD_L_xHL:
    jmp  @IX_LD_L_xHL_Func
    nop

  @IX_LD_L_A:
    jmp  @IX_LD_L_A_Func
    nop

  @IX_LD_xHL_B:
    jmp  @IX_LD_xHL_B_Func
    nop

  @IX_LD_xHL_C:
    jmp  @IX_LD_xHL_C_Func
    nop

  @IX_LD_xHL_D:
    jmp  @IX_LD_xHL_D_Func
    nop

  @IX_LD_xHL_E:
    jmp  @IX_LD_xHL_E_Func
    nop

  @IX_LD_xHL_H:
    jmp  @IX_LD_xHL_H_Func
    nop

  @IX_LD_xHL_L:
    jmp  @IX_LD_xHL_L_Func
    nop

  @IX_HALT:
    jmp  @IX_HALT_Func
    nop

  @IX_LD_xHL_A:
    jmp  @IX_LD_xHL_A_Func
    nop

  @IX_LD_A_B:
    jmp  @IX_LD_A_B_Func
    nop

  @IX_LD_A_C:
    jmp  @IX_LD_A_C_Func
    nop

  @IX_LD_A_D:
    jmp  @IX_LD_A_D_Func
    nop

  @IX_LD_A_E:
    jmp  @IX_LD_A_E_Func
    nop

  @IX_LD_A_H:
    jmp  @IX_LD_A_H_Func
    nop

  @IX_LD_A_L:
    jmp  @IX_LD_A_L_Func
    nop

  @IX_LD_A_xHL:
    jmp  @IX_LD_A_xHL_Func
    nop

  @IX_LD_A_A:
    jmp  @IX_LD_A_A_Func
    nop

  @IX_ADD_B:
    jmp  @IX_ADD_B_Func
    nop

  @IX_ADD_C:
    jmp  @IX_ADD_C_Func
    nop

  @IX_ADD_D:
    jmp  @IX_ADD_D_Func
    nop

  @IX_ADD_E:
    jmp  @IX_ADD_E_Func
    nop

  @IX_ADD_H:
    jmp  @IX_ADD_H_Func
    nop

  @IX_ADD_L:
    jmp  @IX_ADD_L_Func
    nop

  @IX_ADD_xHL:
    jmp  @IX_ADD_xHL_Func
    nop

  @IX_ADD_A:
    jmp  @IX_ADD_A_Func
    nop

  @IX_ADC_B:
    jmp  @IX_ADC_B_Func
    nop

  @IX_ADC_C:
    jmp  @IX_ADC_C_Func
    nop

  @IX_ADC_D:
    jmp  @IX_ADC_D_Func
    nop

  @IX_ADC_E:
    jmp  @IX_ADC_E_Func
    nop

  @IX_ADC_H:
    jmp  @IX_ADC_H_Func
    nop

  @IX_ADC_L:
    jmp  @IX_ADC_L_Func
    nop

  @IX_ADC_xHL:
    jmp  @IX_ADC_xHL_Func
    nop

  @IX_ADC_A:
    jmp  @IX_ADC_A_Func
    nop

  @IX_SUB_B:
    jmp  @IX_SUB_B_Func
    nop

  @IX_SUB_C:
    jmp  @IX_SUB_C_Func
    nop

  @IX_SUB_D:
    jmp  @IX_SUB_D_Func
    nop

  @IX_SUB_E:
    jmp  @IX_SUB_E_Func
    nop

  @IX_SUB_H:
    jmp  @IX_SUB_H_Func
    nop

  @IX_SUB_L:
    jmp  @IX_SUB_L_Func
    nop

  @IX_SUB_xHL:
    jmp  @IX_SUB_xHL_Func
    nop

  @IX_SUB_A:
    jmp  @IX_SUB_A_Func
    nop

  @IX_SBC_B:
    jmp  @IX_SBC_B_Func
    nop

  @IX_SBC_C:
    jmp  @IX_SBC_C_Func
    nop

  @IX_SBC_D:
    jmp  @IX_SBC_D_Func
    nop

  @IX_SBC_E:
    jmp  @IX_SBC_E_Func
    nop

  @IX_SBC_H:
    jmp  @IX_SBC_H_Func
    nop

  @IX_SBC_L:
    jmp  @IX_SBC_L_Func
    nop

  @IX_SBC_xHL:
    jmp  @IX_SBC_xHL_Func
    nop

  @IX_SBC_A:
    jmp  @IX_SBC_A_Func
    nop

  @IX_AND_B:
    jmp  @IX_AND_B_Func
    nop

  @IX_AND_C:
    jmp  @IX_AND_C_Func
    nop

  @IX_AND_D:
    jmp  @IX_AND_D_Func
    nop

  @IX_AND_E:
    jmp  @IX_AND_E_Func
    nop

  @IX_AND_H:
    jmp  @IX_AND_H_Func
    nop

  @IX_AND_L:
    jmp  @IX_AND_L_Func
    nop

  @IX_AND_xHL:
    jmp  @IX_AND_xHL_Func
    nop

  @IX_AND_A:
    jmp  @IX_AND_A_Func
    nop

  @IX_XOR_B:
    jmp  @IX_XOR_B_Func
    nop

  @IX_XOR_C:
    jmp  @IX_XOR_C_Func
    nop

  @IX_XOR_D:
    jmp  @IX_XOR_D_Func
    nop

  @IX_XOR_E:
    jmp  @IX_XOR_E_Func
    nop

  @IX_XOR_H:
    jmp  @IX_XOR_H_Func
    nop

  @IX_XOR_L:
    jmp  @IX_XOR_L_Func
    nop

  @IX_XOR_xHL:
    jmp  @IX_XOR_xHL_Func
    nop

  @IX_XOR_A:
    jmp  @IX_XOR_A_Func
    nop

  @IX_OR_B:
    jmp  @IX_OR_B_Func
    nop

  @IX_OR_C:
    jmp  @IX_OR_C_Func
    nop

  @IX_OR_D:
    jmp  @IX_OR_D_Func
    nop

  @IX_OR_E:
    jmp  @IX_OR_E_Func
    nop

  @IX_OR_H:
    jmp  @IX_OR_H_Func
    nop

  @IX_OR_L:
    jmp  @IX_OR_L_Func
    nop

  @IX_OR_xHL:
    jmp  @IX_OR_xHL_Func
    nop

  @IX_OR_A:
    jmp  @IX_OR_A_Func
    nop

  @IX_CP_B:
    jmp  @IX_CP_B_Func
    nop

  @IX_CP_C:
    jmp  @IX_CP_C_Func
    nop

  @IX_CP_D:
    jmp  @IX_CP_D_Func
    nop

  @IX_CP_E:
    jmp  @IX_CP_E_Func
    nop

  @IX_CP_H:
    jmp  @IX_CP_H_Func
    nop

  @IX_CP_L:
    jmp  @IX_CP_L_Func
    nop

  @IX_CP_xHL:
    jmp  @IX_CP_xHL_Func
    nop

  @IX_CP_A:
    jmp  @IX_CP_A_Func
    nop

  @IX_RET_NZ:
    jmp  @IX_RET_NZ_Func
    nop

  @IX_POP_BC:
    jmp  @IX_POP_BC_Func
    nop

  @IX_JP_NZ:
    jmp  @IX_JP_NZ_Func
    nop

  @IX_JP:
    jmp  @IX_JP_Func
    nop

  @IX_CALL_NZ:
    jmp  @IX_CALL_NZ_Func
    nop

  @IX_PUSH_BC:
    jmp  @IX_PUSH_BC_Func
    nop

  @IX_ADD_BYTE:
    jmp  @IX_ADD_BYTE_Func
    nop

  @IX_RST00:
    jmp  @IX_RST00_Func
    nop

  @IX_RET_Z:
    jmp  @IX_RET_Z_Func
    nop

  @IX_RET:
    jmp  @IX_RET_Func
    nop

  @IX_JP_Z:
    jmp  @IX_JP_Z_Func
    nop

  @IX_PFX_CB:
    jmp  @IX_PFX_CB_Func
    nop

  @IX_CALL_Z:
    jmp  @IX_CALL_Z_Func
    nop

  @IX_CALL:
    jmp  @IX_CALL_Func
    nop

  @IX_ADC_BYTE:
    jmp  @IX_ADC_BYTE_Func
    nop

  @IX_RST08:
    jmp  @IX_RST08_Func
    nop

  @IX_RET_NC:
    jmp  @IX_RET_NC_Func
    nop

  @IX_POP_DE:
    jmp  @IX_POP_DE_Func
    nop

  @IX_JP_NC:
    jmp  @IX_JP_NC_Func
    nop

  @IX_OUTA:
    jmp  @IX_OUTA_Func
    nop

  @IX_CALL_NC:
    jmp  @IX_CALL_NC_Func
    nop

  @IX_PUSH_DE:
    jmp  @IX_PUSH_DE_Func
    nop

  @IX_SUB_BYTE:
    jmp  @IX_SUB_BYTE_Func
    nop

  @IX_RST10:
    jmp  @IX_RST10_Func
    nop

  @IX_RET_C:
    jmp  @IX_RET_C_Func
    nop

  @IX_EXX:
    jmp  @IX_EXX_Func
    nop

  @IX_JP_C:
    jmp  @IX_JP_C_Func
    nop

  @IX_INA:
    jmp  @IX_INA_Func
    nop

  @IX_CALL_C:
    jmp  @IX_CALL_C_Func
    nop

  @IX_PFX_DD:
    jmp  @IX_PFX_DD_Func
    nop

  @IX_SBC_BYTE:
    jmp  @IX_SBC_BYTE_Func
    nop

  @IX_RST18:
    jmp  @IX_RST18_Func
    nop

  @IX_RET_PO:
    jmp  @IX_RET_PO_Func
    nop

  @IX_POP_HL:
    jmp  @IX_POP_HL_Func
    nop

  @IX_JP_PO:
    jmp  @IX_JP_PO_Func
    nop

  @IX_EX_HL_xSP:
    jmp  @IX_EX_HL_xSP_Func
    nop

  @IX_CALL_PO:
    jmp  @IX_CALL_PO_Func
    nop

  @IX_PUSH_HL:
    jmp  @IX_PUSH_HL_Func
    nop

  @IX_AND_BYTE:
    jmp  @IX_AND_BYTE_Func
    nop

  @IX_RST20:
    jmp  @IX_RST20_Func
    nop

  @IX_RET_PE:
    jmp  @IX_RET_PE_Func
    nop

  @IX_LD_PC_HL:
    jmp  @IX_LD_PC_HL_Func
    nop

  @IX_JP_PE:
    jmp  @IX_JP_PE_Func
    nop

  @IX_EX_DE_HL:
    jmp  @IX_EX_DE_HL_Func
    nop

  @IX_CALL_PE:
    jmp  @IX_CALL_PE_Func
    nop

  @IX_PFX_ED:
    jmp  @IX_PFX_ED_Func
    nop

  @IX_XOR_BYTE:
    jmp  @IX_XOR_BYTE_Func
    nop

  @IX_RST28:
    jmp  @IX_RST28_Func
    nop

  @IX_RET_P:
    jmp  @IX_RET_P_Func
    nop

  @IX_POP_AF:
    jmp  @IX_POP_AF_Func
    nop

  @IX_JP_P:
    jmp  @IX_JP_P_Func
    nop

  @IX_DI:
    jmp  @IX_DI_Func
    nop

  @IX_CALL_P:
    jmp  @IX_CALL_P_Func
    nop

  @IX_PUSH_AF:
    jmp  @IX_PUSH_AF_Func
    nop

  @IX_OR_BYTE:
    jmp  @IX_OR_BYTE_Func
    nop

  @IX_RST30:
    jmp  @IX_RST30_Func
    nop

  @IX_RET_M:
    jmp  @IX_RET_M_Func
    nop

  @IX_LD_SP_HL:
    jmp  @IX_LD_SP_HL_Func
    nop

  @IX_JP_M:
    jmp  @IX_JP_M_Func
    nop

  @IX_EI:
    jmp  @IX_EI_Func
    nop

  @IX_CALL_M:
    jmp  @IX_CALL_M_Func
    nop

  @IX_PFX_FD:
    jmp  @IX_PFX_FD_Func
    nop

  @IX_CP_BYTE:
    jmp  @IX_CP_BYTE_Func
    nop

  @IX_RST38:
    jmp  @IX_RST38_Func
    nop

  @IX_NOP_Func:
  { nop }
    jmp  @Exit

  @IX_LD_BC_WORD_Func:
    mov  bx, word ptr si[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr si[BCREG], ax  { BC <- ax }
    jmp  @Exit

  @IX_LD_xBC_A_Func:
    mov  bx, word ptr si[BCREG]  { bx <- BC}
    mov  al, byte ptr si[AREG]   { al <- A}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_INC_BC_Func:
    inc  word ptr si[BCREG]
    jmp  @Exit

  @IX_INC_B_Func:
    xor  bx, bx
    mov  bl, byte ptr si[BREG]
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    inc  byte ptr si[BREG]
    jmp  @Exit

  @IX_DEC_B_Func:
    xor  bx, bx
    mov  bl, byte ptr si[BREG]
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    dec  byte ptr si[BREG]
    jmp  @Exit

  @IX_LD_B_BYTE_Func:
    mov  bx, word ptr si[PCREG]      { bx <- PC }
    inc  word ptr si[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr si[BREG], al       { B <- al }
    jmp  @Exit

  @IX_RLCA_Func:
    rol  byte ptr si[AREG], 1
    jc   @Set_Carry_RLCA
    { Clear half carry, n flag and carry flag }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    jmp  @RLCAExit
  @Set_Carry_RLCA:
    { Clear half carry and n flag }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG))
    or   byte ptr si[FREG], C_FLAG      { Set Carry flag }
  @RLCAExit:
    jmp  @Exit

  @IX_EX_AF_AF_Func:
    mov ax, word ptr si[AF1REG]       { ax <- AF1}
    mov bx, word ptr si[AFREG]       { bx <- AF}
    mov word ptr si[AFREG], ax       { AF <- ax }
    mov word ptr si[AF1REG], bx       { AF1 <- bx }
    jmp  @Exit

  @IX_ADD_HL_BC_Func:
    { clear half, n and carry flags }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr si[BCREG]
    add  word ptr si[IXREG] , ax
    jnc  @NC_ADDIX_BC
    or   byte ptr si[FREG], C_FLAG      { set carry cflag }
  @NC_ADDIX_BC:
    jmp  @Exit

  @IX_LD_A_xBC_Func:
    mov  bx, word ptr si[BCREG]  { bx <- BC}
    call GetByte
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_DEC_BC_Func:
    dec  word ptr si[BCREG]
    jmp  @Exit

  @IX_INC_C_Func:
    xor  bx, bx
    mov  bl, byte ptr si[CREG]
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    inc  byte ptr si[CREG]
    jmp  @Exit

  @IX_DEC_C_Func:
    xor  bx, bx
    mov  bl, byte ptr si[CREG]
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    dec  byte ptr si[CREG]
    jmp  @Exit

  @IX_LD_C_BYTE_Func:
    mov  bx, word ptr si[PCREG]      { bx <- PC }
    inc  word ptr si[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr si[CREG], al       { C <- al }
    jmp  @Exit

  @IX_RRCA_Func:
    ror  byte ptr si[AREG], 1
    jc   @Set_Carry_RRCA
    { Clear half carry, n flag and carry flag }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    jmp  @RRCAExit
  @Set_Carry_RRCA:
    { Clear half carry and n flag }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG))
    or   byte ptr si[FREG], C_FLAG      { Set carry flag }
  @RRCAExit:
    jmp  @Exit

  @IX_DJNZ_Func:
    dec  byte ptr si[BREG]
    jz   @DJNZExit

    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cbw
    add  word ptr si[PCREG], ax
    jmp  @Exit

  @DJNZExit:
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_LD_DE_WORD_Func:
    mov  bx, word ptr si[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr si[DEREG], ax  { DE <- ax }
    jmp  @Exit

  @IX_LD_xDE_A_Func:
    mov  bx, word ptr si[DEREG]  { bx <- DE}
    mov  al, byte ptr si[AREG]   { al <- A}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_INC_DE_Func:
    inc  word ptr si[DEREG]
    jmp  @Exit

  @IX_INC_D_Func:
    xor  bx, bx
    mov  bl, byte ptr si[DREG]
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    inc  byte ptr si[DREG]
    jmp  @Exit

  @IX_DEC_D_Func:
    xor  bx, bx
    mov  bl, byte ptr si[DREG]
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    dec  byte ptr si[DREG]
    jmp  @Exit

  @IX_LD_D_BYTE_Func:
    mov  bx, word ptr si[PCREG]      { bx <- PC }
    inc  word ptr si[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr si[DREG], al       { D <- al }
    jmp  @Exit

  @IX_RLA_Func:
    rcr  byte ptr si[FREG], 1           {paso el C sp a C pc}
    rcl  byte ptr si[AREG], 1           {roto a y meto c}
    rcl  byte ptr si[FREG], 1           {roto F restaurandolo y metiendo el bit salido de A en C sp}
    and  byte ptr si[FREG], 11101101b   {H N a cero}
    jmp  @Exit

  @IX_JR_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cbw
    add  word ptr si[PCREG], ax
    jmp  @Exit

  @IX_ADD_HL_DE_Func:
    { clear half, n and carry flags }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr si[DEREG]
    add  word ptr si[IXREG] , ax
    jnc  @NC_ADDIX_DE
    or   byte ptr si[FREG], C_FLAG      { set carry cflag }
  @NC_ADDIX_DE:
    jmp  @Exit

  @IX_LD_A_xDE_Func:
    mov  bx, word ptr si[DEREG]  { bx <- DE}
    call GetByte
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_DEC_DE_Func:
    dec  word ptr si[DEREG]
    jmp  @Exit

  @IX_INC_E_Func:
    xor  bx, bx
    mov  bl, byte ptr si[EREG]
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    inc  byte ptr si[EREG]
    jmp  @Exit

  @IX_DEC_E_Func:
    xor  bx, bx
    mov  bl, byte ptr si[EREG]
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    dec  byte ptr si[EREG]
    jmp  @Exit

  @IX_LD_E_BYTE_Func:
    mov  bx, word ptr si[PCREG]      { bx <- PC }
    inc  word ptr si[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr si[EREG], al       { E <- al }
    jmp  @Exit

  @IX_RRA_Func:
    rcr  byte ptr si[FREG], 1      {paso el C sp a C pc}
    rcr  byte ptr si[AREG], 1      {roto a y meto c}
    rcl  byte ptr si[FREG], 1      {roto F restaurandolo y metiendo el bit salido de A en C sp}
    and  byte ptr si[FREG], 11101101b  {H N a cero}
    jmp  @Exit

  @IX_JR_NZ_Func:
    test byte ptr si[FREG], 01000000b
    jnz  @JRNZFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cbw
    add  word ptr si[PCREG], ax
    jmp  @Exit

  @JRNZFalse:
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_LD_HL_WORD_Func:
    mov  bx, word ptr si[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr si[IXREG], ax  { IX <- ax }
    jmp  @Exit

  @IX_LD_xWORD_HL_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al                         { ax <- MEMW[PC] }
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]             { skip two bytes }
    mov  bx, ax
    mov  al, byte ptr si[IXLREG]
    call PutByte
    inc  bx
    mov  al, byte ptr si[IXHREG]
    call PutByte
    jmp  @Exit

  @IX_INC_HL_Func:
    inc  word ptr si[IXREG]
    jmp  @Exit

  @IX_INC_H_Func:
    xor  bx, bx
    mov  bl, byte ptr si[IXHREG]
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    inc  byte ptr si[IXHREG]
    jmp  @Exit

  @IX_DEC_H_Func:
    xor  bx, bx
    mov  bl, byte ptr si[IXHREG]
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    dec  byte ptr si[IXHREG]
    jmp  @Exit

  @IX_LD_H_BYTE_Func:
    mov  bx, word ptr si[PCREG]      { bx <- PC }
    inc  word ptr si[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr si[IXHREG], al       { IXH <- al }
    jmp  @Exit

  @IX_DAA_Func:
    xor     dx, dx
    mov     dl, byte ptr si[FREG]
    and     dl, 10011b
    test    dl, 10000b
    jz      @No_Set_3
    or      dl,100b
    and     dl,111b
@No_Set_3:
    shl     dx, 9                  { dx <- dx*512 }
    xor     ax, ax
    mov     al, byte ptr si[AREG]
    add     ax, ax
    add     ax, dx
    mov     bx, ax
    mov     al, byte ptr aDAATable[bx+1]
    mov     byte ptr si[FREG], al
    mov     al, byte ptr aDAATable[bx]
    mov     byte ptr si[AREG], al
    jmp  @Exit

  @IX_JR_Z_Func:
    test byte ptr si[FREG], 01000000b
    jz   @JRZFalse 

    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cbw
    add  word ptr si[PCREG], ax
    jmp  @Exit

  @JRZFalse:
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_ADD_HL_HL_Func:
    { clear half, n and carry flags }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr si[IXREG]
    add  word ptr si[IXREG] , ax
    jnc  @NC_ADDIX_IX
    or   byte ptr si[FREG], C_FLAG      { set carry cflag }
  @NC_ADDIX_IX:
    jmp  @Exit

  @IX_LD_HL_xWORD_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    mov  bx, ax
    call GetByte
    mov  byte ptr si[IXLREG], al
    inc  bx
    call GetByte
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_DEC_HL_Func:
    dec  word ptr si[IXREG]
    jmp  @Exit

  @IX_INC_L_Func:
    xor  bx, bx
    mov  bl, byte ptr si[IXLREG]
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    inc  byte ptr si[IXLREG]
    jmp  @Exit

  @IX_DEC_L_Func:
    xor  bx, bx
    mov  bl, byte ptr si[IXLREG]
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    dec  byte ptr si[IXLREG]
    jmp  @Exit

  @IX_LD_L_BYTE_Func:
    mov  bx, word ptr si[PCREG]      { bx <- PC }
    inc  word ptr si[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr si[IXLREG], al       { IXL <- al }
    jmp  @Exit

  @IX_CPL_Func:
    not  byte ptr si[AREG]
    or   byte ptr si[FREG], 00010010b   { H N a 1 }
    jmp  @Exit

  @IX_JR_NC_Func:
    test byte ptr si[FREG], 00000001b
    jnz  @JRNCFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cbw
    add  word ptr si[PCREG], ax
    jmp  @Exit

  @JRNCFalse:
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_LD_SP_WORD_Func:
    mov  bx, word ptr si[PCREG]  { bx <- PC      }
    call GetByte                 { al <- MEM[PC] }
    xchg ah, al                  { change ah with al }
    inc  bx
    call GetByte                 { al <- MEM[PC+1] }
    xchg ah, al                  { change ah with al, ax <- MEMW[PC] }
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]      { PC = PC+2: skip word value }
    mov  word ptr si[SPREG], ax  { SP <- ax }
    jmp  @Exit

  @IX_LD_xWORD_A_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    mov  bx, ax
    mov  al, byte ptr si[AREG]
    call PutByte
    jmp  @Exit

  @IX_INC_SP_Func:
    inc  word ptr si[SPREG]
    jmp  @Exit

  @IX_INC_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    push bx
    call GetByte
    xor  bx, bx
    mov  bl, al
    push ax
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    pop  ax
    pop  bx
    inc  al
    call PutByte
    jmp  @Exit

  @IX_DEC_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    push bx
    call GetByte
    xor  bx, bx
    mov  bl, al
    push ax
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    pop  ax
    pop  bx
    dec  al
    call PutByte
    jmp  @Exit

  @IX_LD_xHL_BYTE_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    push bx
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    pop  bx
    call PutByte
    jmp  @Exit

  @IX_SCF_Func:
    { Clear half and n flags }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG))
    or   byte ptr si[FREG], C_FLAG      { Set carry flag }
    jmp  @Exit

  @IX_JR_C_Func:
    test byte ptr si[FREG], 00000001b
    jz   @JRCFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cbw
    add  word ptr si[PCREG], ax
    jmp  @Exit

  @JRCFalse:
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_ADD_HL_SP_Func:
    { clear half, n and carry flags }
    and  byte ptr si[FREG], ($FF xor (H_FLAG or N_FLAG or C_FLAG))
    mov  ax, word ptr si[SPREG]
    add  word ptr si[IXREG] , ax
    jnc  @NC_ADDIX_SP
    or   byte ptr si[FREG], C_FLAG      { set carry cflag }
  @NC_ADDIX_SP:
    jmp  @Exit

  @IX_LD_A_xWORD_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    mov  bx, ax
    call GetByte
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_DEC_SP_Func:
    dec  word ptr si[SPREG]
    jmp  @Exit

  @IX_INC_A_Func:
    xor  bx, bx
    mov  bl, byte ptr si[AREG]
    mov  al, byte ptr aIncTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    inc  byte ptr si[AREG]
    jmp  @Exit

  @IX_DEC_A_Func:
    xor  bx, bx
    mov  bl, byte ptr si[AREG]
    mov  al, byte ptr aDecTable[bx]
    and  byte ptr si[FREG], C_FLAG   { dont change carry flag } 
    or   byte ptr si[FREG],al
    dec  byte ptr si[AREG]
    jmp  @Exit

  @IX_LD_A_BYTE_Func:
    mov  bx, word ptr si[PCREG]      { bx <- PC }
    inc  word ptr si[PCREG]          { skip one byte }
    call GetByte                     { al <- MEM[PC] }
    mov  byte ptr si[AREG], al       { A <- al }
    jmp  @Exit

  @IX_CCF_Func:
    test byte ptr si[FREG], C_FLAG      { test carryflag }
    jz   @CarryNotRaised
    or   byte ptr si[FREG], H_FLAG      { Set half flag }
    { reset n and carry flags }
    and  byte ptr si[FREG], ($FF xor (N_FLAG and C_FLAG))
    jmp  @CCFExit
  @CarryNotRaised:
    { reset n and h flags }
    and  byte ptr si[FREG], ($FF xor (N_FLAG and H_FLAG))
    or   byte ptr si[FREG], C_FLAG      { Set carry flag }
  @CCFExit:
    jmp  @Exit

  @IX_LD_B_B_Func:
    mov  al, byte ptr si[BREG]
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_B_C_Func:
    mov  al, byte ptr si[CREG]
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_B_D_Func:
    mov  al, byte ptr si[DREG]
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_B_E_Func:
    mov  al, byte ptr si[EREG]
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_B_H_Func:
    mov  al, byte ptr si[IXHREG]
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_B_L_Func:
    mov  al, byte ptr si[IXLREG]
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_B_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    call GetByte
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_B_A_Func:
    mov  al, byte ptr si[AREG]
    mov  byte ptr si[BREG], al
    jmp  @Exit

  @IX_LD_C_B_Func:
    mov  al, byte ptr si[BREG]
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_C_C_Func:
    mov  al, byte ptr si[CREG]
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_C_D_Func:
    mov  al, byte ptr si[DREG]
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_C_E_Func:
    mov  al, byte ptr si[EREG]
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_C_H_Func:
    mov  al, byte ptr si[IXHREG]
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_C_L_Func:
    mov  al, byte ptr si[IXLREG]
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_C_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    call GetByte
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_C_A_Func:
    mov  al, byte ptr si[AREG]
    mov  byte ptr si[CREG], al
    jmp  @Exit

  @IX_LD_D_B_Func:
    mov  al, byte ptr si[BREG]
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_D_C_Func:
    mov  al, byte ptr si[CREG]
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_D_D_Func:
    mov  al, byte ptr si[DREG]
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_D_E_Func:
    mov  al, byte ptr si[EREG]
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_D_H_Func:
    mov  al, byte ptr si[IXHREG]
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_D_L_Func:
    mov  al, byte ptr si[IXLREG]
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_D_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    call GetByte
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_D_A_Func:
    mov  al, byte ptr si[AREG]
    mov  byte ptr si[DREG], al
    jmp  @Exit

  @IX_LD_E_B_Func:
    mov  al, byte ptr si[BREG]
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_E_C_Func:
    mov  al, byte ptr si[CREG]
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_E_D_Func:
    mov  al, byte ptr si[DREG]
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_E_E_Func:
    mov  al, byte ptr si[EREG]
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_E_H_Func:
    mov  al, byte ptr si[IXHREG]
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_E_L_Func:
    mov  al, byte ptr si[IXLREG]
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_E_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    call GetByte
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_E_A_Func:
    mov  al, byte ptr si[AREG]
    mov  byte ptr si[EREG], al
    jmp  @Exit

  @IX_LD_H_B_Func:
    mov  al, byte ptr si[BREG]
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_LD_H_C_Func:
    mov  al, byte ptr si[CREG]
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_LD_H_D_Func:
    mov  al, byte ptr si[DREG]
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_LD_H_E_Func:
    mov  al, byte ptr si[EREG]
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_LD_H_H_Func:
    mov  al, byte ptr si[IXHREG]
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_LD_H_L_Func:
    mov  al, byte ptr si[IXLREG]
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_LD_H_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    call GetByte
    mov  byte ptr si[HREG], al
    jmp  @Exit

  @IX_LD_H_A_Func:
    mov  al, byte ptr si[AREG]
    mov  byte ptr si[IXHREG], al
    jmp  @Exit

  @IX_LD_L_B_Func:
    mov  al, byte ptr si[BREG]
    mov  byte ptr si[IXLREG], al
    jmp  @Exit

  @IX_LD_L_C_Func:
    mov  al, byte ptr si[CREG]
    mov  byte ptr si[IXLREG], al
    jmp  @Exit

  @IX_LD_L_D_Func:
    mov  al, byte ptr si[DREG]
    mov  byte ptr si[IXLREG], al
    jmp  @Exit

  @IX_LD_L_E_Func:
    mov  al, byte ptr si[EREG]
    mov  byte ptr si[IXLREG], al
    jmp  @Exit

  @IX_LD_L_H_Func:
    mov  al, byte ptr si[IXHREG]
    mov  byte ptr si[IXLREG], al
    jmp  @Exit

  @IX_LD_L_L_Func:
    mov  al, byte ptr si[IXLREG]
    mov  byte ptr si[IXLREG], al
    jmp  @Exit

  @IX_LD_L_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    call GetByte
    mov  byte ptr si[LREG], al
    jmp  @Exit

  @IX_LD_L_A_Func:
    mov  al, byte ptr si[AREG]
    mov  byte ptr si[IXLREG], al
    jmp  @Exit

  @IX_LD_xHL_B_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    mov  al, byte ptr si[BREG]   { al <- B}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_LD_xHL_C_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    mov  al, byte ptr si[CREG]   { al <- C}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_LD_xHL_D_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    mov  al, byte ptr si[DREG]   { al <- D}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_LD_xHL_E_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    mov  al, byte ptr si[EREG]   { al <- E}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_LD_xHL_H_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    mov  al, byte ptr si[HREG]   { al <- H}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_LD_xHL_L_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    mov  al, byte ptr si[LREG]   { al <- L}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_HALT_Func:
    dec  word ptr si[PCREG]
    mov  byte ptr si[HALTED], 1
    jmp  @Exit

  @IX_LD_xHL_A_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    mov  al, byte ptr si[AREG]   { al <- A}
    call PutByte                 { MEM[bx] <- al }
    jmp  @Exit

  @IX_LD_A_B_Func:
    mov  al, byte ptr si[BREG]
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_LD_A_C_Func:
    mov  al, byte ptr si[CREG]
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_LD_A_D_Func:
    mov  al, byte ptr si[DREG]
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_LD_A_E_Func:
    mov  al, byte ptr si[EREG]
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_LD_A_H_Func:
    mov  al, byte ptr si[IXHREG]
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_LD_A_L_Func:
    mov  al, byte ptr si[IXLREG]
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_LD_A_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]  { bx <- IX}
    add  bx, ax
    call GetByte
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_LD_A_A_Func:
    mov  al, byte ptr si[AREG]
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_ADD_B_Func:
    mov  al, byte ptr si[BREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_BOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_BExit
  @ADD_BOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_BExit:
    jmp  @Exit

  @IX_ADD_C_Func:
    mov  al, byte ptr si[CREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_COverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_CExit
  @ADD_COverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_CExit:
    jmp  @Exit

  @IX_ADD_D_Func:
    mov  al, byte ptr si[DREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_DOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_DExit
  @ADD_DOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_DExit:
    jmp  @Exit

  @IX_ADD_E_Func:
    mov  al, byte ptr si[EREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_EOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_EExit
  @ADD_EOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_EExit:
    jmp  @Exit

  @IX_ADD_H_Func:
    mov  al, byte ptr si[HREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_HOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_HExit
  @ADD_HOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_HExit:
    jmp  @Exit

  @IX_ADD_L_Func:
    mov  al, byte ptr si[LREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_LOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_LExit
  @ADD_LOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_LExit:
    jmp  @Exit

  @IX_ADD_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_xHLOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_xHLExit
  @ADD_xHLOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_xHLExit:
    jmp  @Exit

  @IX_ADD_A_Func:
    mov  al, byte ptr si[AREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_AOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_AExit
  @ADD_AOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_AExit:
    jmp  @Exit

  @IX_ADC_B_Func:
    mov  al, byte ptr si[BREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_BOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_BExit
  @ADC_BOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_BExit:
    jmp  @Exit

  @IX_ADC_C_Func:
    mov  al, byte ptr si[CREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_COverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_CExit
  @ADC_COverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_CExit:
    jmp  @Exit

  @IX_ADC_D_Func:
    mov  al, byte ptr si[DREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_DOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_DExit
  @ADC_DOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_DExit:
    jmp  @Exit

  @IX_ADC_E_Func:
    mov  al, byte ptr si[EREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_EOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_EExit
  @ADC_EOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_EExit:
    jmp  @Exit

  @IX_ADC_H_Func:
    mov  al, byte ptr si[HREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_HOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_HExit
  @ADC_HOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_HExit:
    jmp  @Exit

  @IX_ADC_L_Func:
    mov  al, byte ptr si[LREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_LOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_LExit
  @ADC_LOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_LExit:
    jmp  @Exit

  @IX_ADC_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_xHLOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_xHLExit
  @ADC_xHLOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_xHLExit:
    jmp  @Exit

  @IX_ADC_A_Func:
    mov  al, byte ptr si[AREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_AOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_AExit
  @ADC_AOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_AExit:
    jmp  @Exit

  @IX_SUB_B_Func:
    mov  al, byte ptr si[BREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_BOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_BExit
  @SUB_BOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_BExit:
    jmp  @Exit

  @IX_SUB_C_Func:
    mov  al, byte ptr si[CREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_COverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_CExit
  @SUB_COverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_CExit:
    jmp  @Exit

  @IX_SUB_D_Func:
    mov  al, byte ptr si[DREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_DOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_DExit
  @SUB_DOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_DExit:
    jmp  @Exit

  @IX_SUB_E_Func:
    mov  al, byte ptr si[EREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_EOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_EExit
  @SUB_EOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_EExit:
    jmp  @Exit

  @IX_SUB_H_Func:
    mov  al, byte ptr si[HREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_HOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_HExit
  @SUB_HOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_HExit:
    jmp  @Exit

  @IX_SUB_L_Func:
    mov  al, byte ptr si[LREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_LOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_LExit
  @SUB_LOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_LExit:
    jmp  @Exit

  @IX_SUB_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_xHLOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_xHLExit
  @SUB_xHLOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_xHLExit:
    jmp  @Exit

  @IX_SUB_A_Func:
    mov  al, byte ptr si[AREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_AOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_AExit
  @SUB_AOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_AExit:
    jmp  @Exit

  @IX_SBC_B_Func:
    mov  al, byte ptr si[BREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_BOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_BExit
  @SBC_BOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_BExit:
    jmp  @Exit

  @IX_SBC_C_Func:
    mov  al, byte ptr si[CREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_COverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_CExit
  @SBC_COverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_CExit:
    jmp  @Exit

  @IX_SBC_D_Func:
    mov  al, byte ptr si[DREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_DOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_DExit
  @SBC_DOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_DExit:
    jmp  @Exit

  @IX_SBC_E_Func:
    mov  al, byte ptr si[EREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_EOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_EExit
  @SBC_EOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_EExit:
    jmp  @Exit

  @IX_SBC_H_Func:
    mov  al, byte ptr si[HREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_HOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_HExit
  @SBC_HOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_HExit:
    jmp  @Exit

  @IX_SBC_L_Func:
    mov  al, byte ptr si[LREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_LOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_LExit
  @SBC_LOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_LExit:
    jmp  @Exit

  @IX_SBC_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_xHLOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_xHLExit
  @SBC_xHLOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_xHLExit:
    jmp  @Exit

  @IX_SBC_A_Func:
    mov  al, byte ptr si[AREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_AOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_AExit
  @SBC_AOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_AExit:
    jmp  @Exit

  @IX_AND_B_Func:
    mov  al, byte ptr si[BREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_AND_C_Func:
    mov  al, byte ptr si[CREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_AND_D_Func:
    mov  al, byte ptr si[DREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_AND_E_Func:
    mov  al, byte ptr si[EREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_AND_H_Func:
    mov  al, byte ptr si[HREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_AND_L_Func:
    mov  al, byte ptr si[LREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_AND_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_AND_A_Func:
    mov  al, byte ptr si[AREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_B_Func:
    mov  al, byte ptr si[BREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_C_Func:
    mov  al, byte ptr si[CREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_D_Func:
    mov  al, byte ptr si[DREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_E_Func:
    mov  al, byte ptr si[EREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_H_Func:
    mov  al, byte ptr si[HREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_L_Func:
    mov  al, byte ptr si[LREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_XOR_A_Func:
    mov  al, byte ptr si[AREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_B_Func:
    mov  al, byte ptr si[BREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_C_Func:
    mov  al, byte ptr si[CREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_D_Func:
    mov  al, byte ptr si[DREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_E_Func:
    mov  al, byte ptr si[EREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_H_Func:
    mov  al, byte ptr si[HREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_L_Func:
    mov  al, byte ptr si[LREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_OR_A_Func:
    mov  al, byte ptr si[AREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_CP_B_Func:
    mov  al, byte ptr si[BREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_BOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_BExit
  @CP_BOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_BExit:
    jmp  @Exit

  @IX_CP_C_Func:
    mov  al, byte ptr si[CREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_COverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_CExit
  @CP_COverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_CExit:
    jmp  @Exit

  @IX_CP_D_Func:
    mov  al, byte ptr si[DREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_DOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_DExit
  @CP_DOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_DExit:
    jmp  @Exit

  @IX_CP_E_Func:
    mov  al, byte ptr si[EREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_EOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_EExit
  @CP_EOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_EExit:
    jmp  @Exit

  @IX_CP_H_Func:
    mov  al, byte ptr si[HREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_HOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_HExit
  @CP_HOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_HExit:
    jmp  @Exit

  @IX_CP_L_Func:
    mov  al, byte ptr si[LREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_LOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_LExit
  @CP_LOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_LExit:
    jmp  @Exit

  @IX_CP_xHL_Func:
    mov  bx, word ptr si[PCREG]
    inc  word ptr si[PCREG]
    call GetByte
    cbw
    mov  bx, word ptr si[IXREG]
    add  bx, ax
    call GetByte
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_xHLOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_xHLExit
  @CP_xHLOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_xHLExit:
    jmp  @Exit

  @IX_CP_A_Func:
    mov  al, byte ptr si[AREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_AOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_AExit
  @CP_AOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_AExit:
    jmp  @Exit

  @IX_RET_NZ_Func:
    test byte ptr si[FREG], 01000000b
    jnz  @RETNZFalse

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETNZFalse:
    jmp  @Exit

  @IX_POP_BC_Func:
    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[CREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[BREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @IX_JP_NZ_Func:
    test byte ptr si[FREG], 01000000b
    jnz  @JPNZFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPNZFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_JP_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @IX_CALL_NZ_Func:
    test byte ptr si[FREG], 01000000b
    jnz  @CALLNZFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLNZFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PUSH_BC_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[BREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[CREG]
    call PutByte
    jmp  @Exit

  @IX_ADD_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    add  byte ptr si[AREG], al
    lahf
    jo   @ADD_BYTEOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADD_BYTEExit
  @ADD_BYTEOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADD_BYTEExit:
    jmp  @Exit

  @IX_RST00_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0000
    jmp  @Exit

  @IX_RET_Z_Func:
    test byte ptr si[FREG], 01000000b
    jz   @RETZFalse 

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETZFalse:
    jmp  @Exit

  @IX_RET_Func:
    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @IX_JP_Z_Func:
    test byte ptr si[FREG], 01000000b
    jz   @JPZFalse 

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPZFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PFX_CB_Func:
    call OpcodeDDCB
    jmp  @Exit

  @IX_CALL_Z_Func:
    test byte ptr si[FREG], 01000000b
    jz   @CALLZFalse 

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLZFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_CALL_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @IX_ADC_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    ror  byte ptr si[FREG], 1
    adc  byte ptr si[AREG], al
    lahf
    jo   @ADC_BYTEOverflow
  {Sin overflow}
    and  ah, 11111001b    { Overflow y N a 0}
    mov  byte ptr si[FREG], ah
    jmp  @ADC_BYTEExit
  @ADC_BYTEOverflow:
    and  ah, 11111101b    { N a 0}
    or   ah, 00000100b    { Overflow a 1}
    mov  byte ptr si[FREG], ah
  @ADC_BYTEExit:
    jmp  @Exit

  @IX_RST08_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0008
    jmp  @Exit

  @IX_RET_NC_Func:
    test byte ptr si[FREG], 00000001b
    jnz  @RETNCFalse

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETNCFalse:
    jmp  @Exit

  @IX_POP_DE_Func:
    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[EREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[DREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @IX_JP_NC_Func:
    test byte ptr si[FREG], 00000001b
    jnz  @JPNCFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPNCFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_OUTA_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    mov  bx, ax
    inc  word ptr si[PCREG]
    mov  al, byte ptr si[AREG]
    call OutByte
    jmp  @Exit

  @IX_CALL_NC_Func:
    test byte ptr si[FREG], 00000001b
    jnz  @CALLNCFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLNCFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PUSH_DE_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[DREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[EREG]
    call PutByte
    jmp  @Exit

  @IX_SUB_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    sub  byte ptr si[AREG], al
    lahf
    jo   @SUB_BYTEOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SUB_BYTEExit
  @SUB_BYTEOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SUB_BYTEExit:
    jmp  @Exit

  @IX_RST10_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0010
    jmp  @Exit

  @IX_RET_C_Func:
    test byte ptr si[FREG], 00000001b
    jz   @RETCFalse

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETCFalse:
    jmp  @Exit

  @IX_EXX_Func:
    mov  ax, word ptr si[BCREG]
    mov  bx, word ptr si[BC1REG]
    mov  word ptr si[BCREG], bx
    mov  word ptr si[BC1REG], ax
    mov  ax, word ptr si[DEREG]
    mov  bx, word ptr si[DE1REG]
    mov  word ptr si[DEREG], bx
    mov  word ptr si[DE1REG], ax
    mov  ax, word ptr si[HLREG]
    mov  bx, word ptr si[HL1REG]
    mov  word ptr si[HLREG], bx
    mov  word ptr si[HL1REG], ax
    jmp  @Exit

  @IX_JP_C_Func:
    test byte ptr si[FREG], 00000001b
    jz   @JPCFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPCFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_INA_Func:
    mov  bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    call InByte
    mov  byte ptr si[AREG], al
    jmp  @Exit

  @IX_CALL_C_Func:
    test byte ptr si[FREG], 00000001b
    jz   @CALLCFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLCFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PFX_DD_Func:
    call OpcodeDD
    jmp  @Exit

  @IX_SBC_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    ror  byte ptr si[FREG], 1
    sbb  byte ptr si[AREG], al
    lahf
    jo   @SBC_BYTEOverflow
  {Sin overflow}
    and  ah, 11111011b    { Overflow  a 0}
    or   ah, 00000010b    { N a 1}
    mov  byte ptr si[FREG], ah
    jmp  @SBC_BYTEExit
  @SBC_BYTEOverflow:
    or   ah, 00000110b    { Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @SBC_BYTEExit:
    jmp  @Exit

  @IX_RST18_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0018
    jmp  @Exit

  @IX_RET_PO_Func:
    test byte ptr si[FREG], 00000100b
    jnz  @RETPOFalse

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETPOFalse:
    jmp  @Exit

  @IX_POP_HL_Func:
    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[IXLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[IXHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @IX_JP_PO_Func:
    test byte ptr si[FREG], 00000100b
    jnz  @JPPOFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPPOFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_EX_HL_xSP_Func:
    mov  bx, word ptr si[SPREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  dx, word ptr si[HLREG]
    mov  word ptr si[HLREG], ax
    mov  bx, word ptr si[SPREG]
    mov  ax, dx
    call PutByte
    inc  bx
    xchg ah,al
    call PutByte
    jmp  @Exit

  @IX_CALL_PO_Func:
    test byte ptr si[FREG], 00000100b
    jnz  @CALLPOFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLPOFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PUSH_HL_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[IXHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[IXLREG]
    call PutByte
    jmp  @Exit

  @IX_AND_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    and  byte ptr si[AREG], al
    lahf
    and  ah, 11111100b    {N C a cero}
    or   ah, 00010000b    {H a 1}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_RST20_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0020
    jmp  @Exit

  @IX_RET_PE_Func:
    test byte ptr si[FREG], 00000100b
    jz   @RETPEFalse

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETPEFalse:
    jmp  @Exit

  @IX_LD_PC_HL_Func:
    mov  ax, word ptr si[IXREG]
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @IX_JP_PE_Func:
    test byte ptr si[FREG], 00000100b
    jz   @JPPEFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPPEFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_EX_DE_HL_Func:
    mov ax, word ptr si[DEREG]       { ax <- DE}
    mov bx, word ptr si[IXREG]       { bx <- IX}
    mov word ptr si[IXREG], ax       { IX <- ax }
    mov word ptr si[DEREG], bx       { DE <- bx }
    jmp  @Exit

  @IX_CALL_PE_Func:
    test byte ptr si[FREG], 00000100b
    jz   @CALLPEFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLPEFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PFX_ED_Func:
    call OpcodeDDED
    jmp  @Exit

  @IX_XOR_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    xor  byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {H N C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_RST28_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0028
    jmp  @Exit

  @IX_RET_P_Func:
    test byte ptr si[FREG], 10000000b
    jnz  @RETPFalse

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETPFalse:
    jmp  @Exit

  @IX_POP_AF_Func:
    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[FREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[AREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @IX_JP_P_Func:
    test byte ptr si[FREG], 10000000b
    jnz  @JPPFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPPFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_DI_Func:
    mov  byte ptr si[IFF1], $00
    mov  byte ptr si[IFF2], $00
    jmp  @Exit

  @IX_CALL_P_Func:
    test byte ptr si[FREG], 10000000b
    jnz  @CALLPFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLPFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PUSH_AF_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[AREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[FREG]
    call PutByte
    jmp  @Exit

  @IX_OR_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    or   byte ptr si[AREG], al
    lahf
    and  ah, 11101100b    {N H C a cero}
    mov  byte ptr si[FREG], ah
    jmp  @Exit

  @IX_RST30_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0030
    jmp  @Exit

  @IX_RET_M_Func:
    test byte ptr si[FREG], 10000000b
    jz   @RETMFalse

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCLREG], al
    inc  word ptr si[SPREG]

    mov  bx, word ptr si[SPREG]
    call GetByte
    mov  byte ptr si[PCHREG], al
    inc  word ptr si[SPREG]
    jmp  @Exit

  @RETMFalse:
    jmp  @Exit

  @IX_LD_SP_HL_Func:
    mov  ax, word ptr si[IXREG]
    mov  word ptr si[SPREG], ax
    jmp  @Exit

  @IX_JP_M_Func:
    test byte ptr si[FREG], 10000000b
    jz   @JPMFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @JPMFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_EI_Func:
    cmp  byte ptr si[IFF1], $00
    jne  @IFF1NotZero
    mov  byte ptr si[IFF1], $01
    mov  byte ptr si[IFF2], $01
    inc  byte ptr si[RREG]
    jmp  @ExitEI
  @IFF1NotZero:
    mov  byte ptr si[IFF2], $01
  @ExitEI:
    jmp  @Exit

  @IX_CALL_M_Func:
    test byte ptr si[FREG], 10000000b
    jz   @CALLMFalse

    mov  bx, word ptr si[PCREG]
    call GetByte
    xchg ah, al
    inc  bx
    call GetByte
    xchg ah, al
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    push ax
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte
    pop  ax
    mov  word ptr si[PCREG], ax
    jmp  @Exit

  @CALLMFalse:
    inc  word ptr si[PCREG]
    inc  word ptr si[PCREG]
    jmp  @Exit

  @IX_PFX_FD_Func:
    call OpcodeFD
    jmp  @Exit

  @IX_CP_BYTE_Func:
    mov bx, word ptr si[PCREG]
    call GetByte
    inc  word ptr si[PCREG]
    cmp byte ptr si[AREG], al
    lahf
    jo   @CP_BYTEOverflow
    {;Sin overflow}
    and  ah,11111011b    {Overflow a 0}
    or   ah,00000010b    {N a 1}
    mov  byte ptr si[FREG],ah
    jmp  @CP_BYTEExit
  @CP_BYTEOverflow:
    or   ah, 00000110b    {Overflow y N a 1}
    mov  byte ptr si[FREG], ah
  @CP_BYTEExit:
    jmp  @Exit

  @IX_RST38_Func:
    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCHREG]
    call PutByte

    dec  word ptr si[SPREG]
    mov  bx, word ptr si[SPREG]
    mov  al, byte ptr si[PCLREG]
    call PutByte

    mov word ptr si[PCREG], $0038
    jmp  @Exit

  @Exit:
end;
